import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class avsPanel extends JPanel {

String[] conf; 
String[] params;
JTextField[] s;
ActionListener[] al;
JPanel[] pp;
int n;
String AVSFileName;
  desktop d;
  String selectedServer;

  public avsPanel( desktop d, String selectedServer )
   {
    
     this.d = d;
    this.selectedServer = selectedServer;
    n =d.n_AVS;
  
  conf = new String[n];
  for(int i=0;i<n;i++) {
     conf[i]="";
  }
  s = new JTextField[n];
  params = new String[n];
  
  params[0]="          WebServer Base URL ";
  params[1]="               Document Root ";
  params[2]="              Data Directory ";
  params[3]="   Parssim Working Directory "; 
  params[4]="       Client Side Data Root " ;
  params[5]="Client Side Working Directory";

  pp = new JPanel[n];
  al = new ActionListener[n];  
  
  AVSFileName = selectedServer+"AVS.conf";

  conf[0] = "http://osprey4.npac.syr.edu:8001/ParssimData/data/";
  conf[1] = "/tmp/data/";
  conf[2] = "parssim1/transData/";
  conf[3] = conf[1]+"/"+conf[2];
  conf[4] = "/project/gateway/WebFlow/CRPCclient/";
  conf[5] = "data";
  
  File conffile = new File(AVSFileName);
  if(conffile.exists()) {
    try {
      FileReader fr = new FileReader(conffile);
      BufferedReader in = new BufferedReader(fr);
      String nextline = in.readLine();
      in.close();
      StringTokenizer st = new StringTokenizer(nextline,"+");
      for(int i=0; i<n; i++) {
        conf[i] = st.nextToken();
      }
      d.setAVSConfig(conf);
   }
    catch (Exception e) {System.out.println(e);}
  }  
  else {
    System.out.println("new configuration");
  }



  setLayout(new BorderLayout());

  JPanel ss = new JPanel();
  ss.setLayout(new GridLayout(n,1));


   
  JLabel l;
  for (int i = 0; i<n; i++) {
     pp[i] = new JPanel();
     pp[i].setLayout(new BorderLayout());
     l = new JLabel(params[i],JLabel.CENTER);
 //    l.resize(500,4);
   //  l.setText(params[i]);
     l.setFont(new Font("Courier", Font.BOLD, 12));
     l.setForeground(Color.black);
     pp[i].add(l,BorderLayout.WEST);
     s[i] = new JTextField(conf[i]);
     s[i].setPreferredSize(new Dimension(10,5));
     pp[i].add(s[i],BorderLayout.CENTER);
     ss.add(pp[i]);  
  }
  
  add(ss,BorderLayout.CENTER);
  
  JPanel bp = new JPanel();
  bp.setLayout(new GridLayout(1,2));
  JButton b1 = new JButton("Commit");
  b1.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent e) {
       commit();
    }
  });
  bp.add(b1);

  JButton b2 = new JButton("Reset");
  b2.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent e) {
       reset();
    }
  });
  bp.add(b2);
  add(bp,BorderLayout.SOUTH);
  }


  public void setWFconf(int i, String h) {
     conf[i]=h;
  } 

  public void commit() {

     for(int i=0;i<n;i++) {
       conf[i]=s[i].getText();
     }  

     d.setAVSConfig(conf);
     try {    
        FileWriter fw = new FileWriter(AVSFileName);
        for (int i=0;i<n;i++) {
          if(conf[i].length()<1) fw.write("null+"); 
          else fw.write(conf[i]+"+");
        }
        fw.flush();
        fw.close();
       
     }
     catch (Exception e) { System.out.println(e);}

  }

  public void reset() {
    for(int i=0;i<n;i++) {
     conf[i]="";
     s[i].setText("");
    }
  }
/*      public static void main(String args[])
  {
  System.out.println("Standalone");
  avsPanel a = new avsPanel();
  JFrame F = new JFrame();
F.setBounds(100,100,2000,800);
// F.setSize(500,500);
  F.getContentPane().add(a);
  // F.setSize(500,500);
   F.pack();
F.show();
  }*/

}



